/** @license num-to-korean v0.5.3
* https://github.com/huskyhoochu/num-to-korean
* (c) 2020-2024 Seung Hyung Soo
* This source code is licensed under the MIT license found in the
* LICENSE file in the root directory of this source tree.
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).numToKorean={})}(this,(function(t){"use strict";function e(t,e,n){if(n||2===arguments.length)for(var o,r=0,i=e.length;r<i;r++)!o&&r in e||(o||(o=Array.prototype.slice.call(e,0,r)),o[r]=e[r]);return t.concat(o||Array.prototype.slice.call(e))}"function"==typeof SuppressedError&&SuppressedError;var n=["","일","이","삼","사","오","육","칠","팔","구"],o=["","십","백","천"],r=["","만","억","조","경"];function i(t,e){for(var n=[],o=0;o<e.length;)n.push(e.slice(o,o+=t));return n}var s={NORMAL:"normal",SPACING:"spacing",MIXED:"mixed",LINGUAL:"lingual",LINGUAL_SPACING:"lingual_spacing",FLOAT:"float"},u=function(){function t(e,n){this.originNum=0,this.formatOption="normal",this.token=[],this.result=[],this.originNum=t.isInteger(e)?e:0,this.formatOption=n}return t.isInteger=function(t){return isFinite(t)&&Math.floor(t)===t},t.prototype.getToken=function(){return this.token=this.originNum.toString().split("").map((function(t){return parseInt(t,10)})).reverse().map((function(t,e){var n=e%4,i=Math.ceil(e/4);return{num:t,power:0===t?"":o[n],dot:0===n?r[i]:""}})),this},t.prototype.flatToken=function(t){return this.result=this.token.map((function(e){if(t)return"".concat(e.num).concat(e.dot);var o=n[e.num]||"";return"".concat(o).concat(e.power).concat(e.dot)})),this},t.prototype.flatTokenForFloatMode=function(){var t=[],e="";return this.token.forEach((function(e){t.push(e.dot)})),void 0===(e=t.join("").split("").slice(-1)[0])?(t=[],this.token.forEach((function(e){t.push(e.power)})),e=t.join("").split("").slice(-1)[0],this.result=this.token.map((function(t){return"".concat(t.num).concat(t.power===e?".".concat(t.power):"")})),this):(this.result=this.token.map((function(t){return"".concat(t.num).concat(t.dot===e?".".concat(t.dot):"")})),this)},t.prototype.moveToDotLast=function(){var t=this.result.join("").match(/\.(십|백|천|만|억|조|경)/);if(t){var n=t[1],o=this.result.join("").replace(/(십|백|천|만|억|조|경)/g,"").split("");this.result=e(e([],o,!0),[n],!1)}else this.result=this.result.map((function(t){return t.replace(/\./g,"")}));return this},t.prototype.removeUnnecessaryChars=function(){return this.result=this.result.join("").replace(/\..*/,(function(t){return t.replace(/,/g,"")})).replace(/\.(?=[십백천만억조경]|$)/,"").replace(/\.(\d*[1-9])?(0+)(?=[십백천만억조경])/,(function(t,e){return e?".".concat(e):""})).split(""),this},t.prototype.swapZeroToComma=function(){return this.result=i(4,this.result).map((function(t){var e=function(t,e){for(var n=e.length-1;n>=0&&t(e[n]);)n-=1;return e.slice(0,n+1)}((function(t){return 0===parseInt(t,10)}),t);return 4===e.length&&e.splice(3,0,","),e})).reduce((function(t,e){return t.concat(e)}),[]),this},t.prototype.onlyAddComma=function(){return this.result=i(4,this.result).map((function(t){return 4===t.length&&t.splice(3,0,","),t})).reduce((function(t,e){return t.concat(e)}),[]),this},t.prototype.onlyReverse=function(){return this.result=this.result.reverse(),this},t.prototype.addEmptyPositionWhenSymbolHasValue=function(){return this.result=i(4,this.result).map((function(t){return r.indexOf(t.join(""))>0?["","","",""]:t})).reduce((function(t,e){return t.concat(e)}),[]),this},t.prototype.addSpacing=function(){return this.result=this.result.filter((function(t){return t})).map((function(t){return r.indexOf(t.slice(-1))>0?"".concat(t," "):t})),this},t.prototype.removeOneStr=function(){if(1===this.result.length)return this;for(var t=[],e=0;e<this.result.length;e+=1){if(e===this.result.length-1){t.push(this.result[e]);break}this.result.length>5&&r.indexOf(this.result[e].slice(1))>0?t.push(this.result[e]):this.result[e].slice(0,1)===n[1]?t.push(this.result[e].slice(1)):t.push(this.result[e])}return this.result=t,this},t.prototype.makeZeroIfResultEmpty=function(){return(1===this.result.length&&""===this.result[0]||0===this.result.length)&&(this.result=["0"]),this},t.prototype.getResult=function(){return this.result},t.prototype.getNormal=function(){return this.getToken().flatToken(!1).addEmptyPositionWhenSymbolHasValue().onlyReverse().getResult().join("")},t.prototype.getLingual=function(){return this.getToken().flatToken(!1).addEmptyPositionWhenSymbolHasValue().onlyReverse().removeOneStr().getResult().join("")},t.prototype.getSpacing=function(){return this.getToken().flatToken(!1).addEmptyPositionWhenSymbolHasValue().onlyReverse().addSpacing().getResult().join("").trim()},t.prototype.getLingualSpacing=function(){return this.getToken().flatToken(!1).addEmptyPositionWhenSymbolHasValue().onlyReverse().removeOneStr().addSpacing().getResult().join("").trim()},t.prototype.getMixed=function(){return this.getToken().flatToken(!0).swapZeroToComma().onlyReverse().addSpacing().makeZeroIfResultEmpty().getResult().join("").trim()},t.prototype.getFloat=function(){return this.getToken().flatTokenForFloatMode().onlyAddComma().onlyReverse().moveToDotLast().removeUnnecessaryChars().makeZeroIfResultEmpty().getResult().join("").trim()},t.prototype.getKorean=function(){return this.formatOption===s.SPACING?this.getSpacing():this.formatOption===s.MIXED?this.getMixed():this.formatOption===s.LINGUAL?this.getLingual():this.formatOption===s.LINGUAL_SPACING?this.getLingualSpacing():this.formatOption===s.NORMAL?this.getNormal():this.formatOption===s.FLOAT?this.getFloat():this.getNormal()},t}();t.FormatOptions=s,t.numToKorean=function(t,e){return new u(t,e||s.NORMAL).getKorean()},Object.defineProperty(t,"__esModule",{value:!0})}));
